/*******************************************************************
 * IVXR[v@f[^W{[h
 *   PIC24FJ64GC006 10Msps̃pCvC^ADCgp
 * @Timer2A/DϊADMA2716obt@Ɋi[
 *   \ȕϊx́@4MspsE@Tad=8MHz
 * @R}hŉLs
 * @@T@FϊJn@2000̃TvO𑗐M
 *******************************************************************/
#include <xc.h>
#include <p24FJ64GC006.h>
/* RtBM[V̐ݒ */
// CONFIG4
#pragma config DSWDTPS = DSWDTPS1F      // Deep Sleep Watchdog Timer Postscale Select bits (1:68719476736 (25.7 Days))
#pragma config DSWDTOSC = LPRC          // DSWDT Reference Clock Select (DSWDT uses LPRC as reference clock)
#pragma config DSBOREN = OFF            // Deep Sleep BOR Enable bit (DSBOR Disabled)
#pragma config DSWDTEN = OFF            // Deep Sleep Watchdog Timer Enable (DSWDT Disabled)
#pragma config DSSWEN = OFF             // DSEN Bit Enable (Deep Sleep operation is always disabled)
#pragma config RTCBAT = OFF             // RTC Battery Operation Enable (RTC operation is discontinued in VBAT)
#pragma config PLLDIV = DIV2            // PLL Input Prescaler Select bits (Oscillator divided by 2 (8 MHz input))
#pragma config I2C2SEL = PRI            // Alternate I2C2 Location Select bit (I2C2 is multiplexed to SDA2/RA3 and SCL2/RA2 )
#pragma config IOL1WAY = OFF            // PPS IOLOCK Set Only Once Enable bit (The IOLOCK bit can be set and cleared using the unlock sequence)

// CONFIG3
#pragma config WPFP = WPFP127           // Write Protection Flash Page Segment Boundary (Page 127 (0x1FC00))
#pragma config SOSCSEL = OFF            // SOSC Selection bits (Digital (SCLKI) mode)
#pragma config WDTWIN = PS25_0          // Window Mode Watchdog Timer Window Width Select (Watch Dog Timer Window Width is 25 percent)
#pragma config BOREN = OFF              // Brown-out Reset Enable (Brown-out Reset Disabled)
#pragma config WPDIS = WPDIS            // Segment Write Protection Disable (Disabled)
#pragma config WPCFG = WPCFGDIS         // Write Protect Configuration Page Select (Disabled)
#pragma config WPEND = WPENDMEM         // Segment Write Protection End Page Select (Write Protect from WPFP to the last page of memory)

// CONFIG2
#pragma config POSCMD = EC              // Primary Oscillator Select (External-Clock Mode Enabled)
#pragma config WDTCLK = LPRC            // WDT Clock Source Select bits (WDT uses LPRC)
//#pragma config OSCIOFCN = OFF           // OSCO Pin Configuration (OSCO/CLKO/RC15 functions as CLKO (FOSC/2))
#pragma config FCKSM = CSDCMD           // Clock Switching and Fail-Safe Clock Monitor Configuration bits (Clock switching and Fail-Safe Clock Monitor are disabled)
#pragma config FNOSC = PRIPLL           // Initial Oscillator Select (Primary Oscillator with PLL module (XTPLL,HSPLL, ECPLL))
#pragma config ALTADREF = AVREF_RA      // External 12-Bit A/D Reference Location Select bit (AVREF+/AVREF- are mapped to RA9/RA10)
#pragma config ALTCVREF = CVREF_RA      // External Comparator Reference Location Select bit (CVREF+/CVREF- are mapped to RA9/RA10)
#pragma config WDTCMX = WDTCLK          // WDT Clock Source Select bits (WDT clock source is determined by the WDTCLK Configuration bits)
#pragma config IESO = OFF               // Internal External Switchover (Disabled)

// CONFIG1
#pragma config WDTPS = PS32768          // Watchdog Timer Postscaler Select (1:32,768)
#pragma config FWPSA = PR128            // WDT Prescaler Ratio Select (1:128)
#pragma config WINDIS = OFF             // Windowed WDT Disable (Standard Watchdog Timer)
#pragma config FWDTEN = WDT_DIS         // Watchdog Timer Enable (WDT disabled in hardware; SWDTEN bit disabled)
#pragma config ICS = PGx2               // Emulator Pin Placement Select bits (Emulator functions are shared with PGEC2/PGED2)
#pragma config LPCFG = ON               // Low power regulator control (Low voltage regulator controlled in sw by RETEN bit)
#pragma config GWRP = OFF               // General Segment Write Protect (Disabled)
#pragma config GCP = OFF                // General Segment Code Protect (Code protection is disabled)
#pragma config JTAGEN = OFF             // JTAG Port Enable (Disabled)

/* O[oϐA萔` */
unsigned char Flag, Find, Rise;
int Index, i, temp, ptr, Trig;
#define  Max_Size 2716                  // TvO
__attribute__((far)) unsigned char RcvBuf[16];              // Mobt@
__attribute__((far)) unsigned int Buffer[Max_Size+10];      // Max 2716+10word

/* ֐vg^CsO */
void Send(unsigned char Data);
void Init(void);
void SendData(unsigned int * buf);
void SendCmd(const unsigned char *cmd);
void Delayms( unsigned int t);
void Hsync(unsigned char num);

/*********** C֐ **************************/
int main(void){
    /* NbN̐ݒ@8MHz96MHz3=32MHz */
    CLKDIVbits.RCDIV = 0;               // 1/1 8MHz
    CLKDIVbits.CPDIV = 0;               // 32/1= 32MHz
    /* I/Ȍݒ */
    TRISB = 0x4F3F;                     // RB1-5,RB14 Input
    TRISE = 0;                          // ׂOutput
    TRISF = 0x0020;                     // RF5 input
    TRISG = 0x03C0;                     // RG6,7,8,9 Input
    /* AiOsw */    
    ANSF = 0;                           // ׂăfW^
    ANSB = 0;                           // fW^ɃZbg
    ANSG = 0;                           // fW^ɃZbg
    ANSGbits.ANSG7 = 1;                 // AN18 CH1
    ANSGbits.ANSG8 = 1;                 // AN19 CH2
    /* ^C}2ݒiA/DϊgKpj */
    T2CON = 0;                          // Prescaler 1/1
    TMR2 = 0;                           // JE^NA
    PR2 = 3;                            // 250nsec period (4MHz)
    /* UART1st */
    RPINR18bits.U1RXR = 17;             // UART1 RX to RP17(RF5)
    RPOR5bits.RP10R = 3;                // UART1 TX to RP10(RF4)
    /* UART1ݒ@115kbps  */
    U1MODE = 0x8808;                    // UART1ݒ BRGH=1
    U1STA =  0x0400;                    // UART1ݒ
    U1BRG = 34;                         // 115kbps@16MHz
    IPC2bits.U1RXIP = 4;                // UART1荞݃x
    IFS0bits.U1RXIF = 0;                // 荞݃tONA
    /** DMAAADCݒ **/
    Init();
    /** ADC Start & Ready DMA **/
    ADSTATLbits.SL0IF = 0;              // ADC Flag Clear
    DMACH0bits.CHEN = 1;                // DMA Channel Enable & Start
    IFS0bits.DMA0IF = 0;                // DMA Interrupt Flag Reset
    /* ϐ */ 
    Index = 0;                          // ԂɃZbg
    Flag = 0;
    Trig = 0;                           // gKx
    Rise = 1;                           // tOZbg
    /* UART1 荞݋ */
    IEC0bits.U1RXIE = 1;                // UART1M荞݋
    LATEbits.LATE4 = 1;

    /*************** C[v ********************/
    while(1){
        /* MR}h */
        if((Flag == 1) && (RcvBuf[0] == 'S')) {
            Flag = 0;                                       // MtONA
            /* f[^  */
            switch(RcvBuf[1]){                              // Mf[^ŕ
                /** f[^vJngK ***/
                case 'T':
                    LATEbits.LATE2 = 1; 
                    if(RcvBuf[3] == '1')                    // `l؂ւĂяo
                        ADTBL0bits.ADCH = 18;               // `lPI 
                    else
                        ADTBL0bits.ADCH = 19;               // `lQI
                    /* TvOݒƃf[^M */
                    T2CONbits.TON = 0;                      // ^C}2~
                    TMR2 = 0;                               // ^C}2Zbg
                    Hsync(RcvBuf[2]);                       // Tvݒ
                    Index = 0;                              // obt@CfbNX
                    /*** Max_SizeTvOI҂ ***/
                    T2CONbits.TON = 1;                      // ^C}2JnATvOJn
                    while(IFS0bits.DMA0IF == 0);            // Wait Max_Size sampling
                    T2CONbits.TON = 0;                      // Stop Timer2 & ADC
                    IFS0bits.DMA0IF = 0;                    // Clear DMA Interrupt Flag
                    /* WgKo@*/
                    /* ŏ216Tv500Tv̊ԂŌo */
                    Trig = (RcvBuf[4]-0x30)*1000+(RcvBuf[5]-0x30)*100+(RcvBuf[6]-0x30)*10+RcvBuf[7]-0x30;         // gKxo
                    Rise = RcvBuf[8];                       // Ao
                    ptr = 216;                              // oJnʒu
                    Find = 0;                               // otONA
                    while((ptr < 716) && (Find == 0)){      //ŏ500TvŌos
                        if(Rise == '1'){
                            if((Buffer[ptr] >= Trig)&&(Buffer[ptr-1] < Trig)&&
                                    (Buffer[ptr] > Buffer[ptr-1]+5))
                                Find = 1;
                        }
                        else{
                            if((Buffer[ptr] <= Trig)&&(Buffer[ptr-1] > Trig)&&
                                    (Buffer[ptr] < Buffer[ptr-1]-5))
                                Find = 1;
                        }
                        ptr++;
                    }                    
                    /* WAf[^Ms */
                    /* gKm̑O200Tv2000Tv𑗐M*/
                    Send('S');
                    Send('M');
                    if(Find == 0){                      // gKmłȂƂ
                        SendData(&Buffer[216]);         // ŏ2000Tv
                    }
                    else{                               // gKołƂ
                        SendData(&Buffer[ptr-200]);     // gKoʒuO200Tv
                    }
                    Send('E');
                    LATEbits.LATE2 = 0;                    
                    break;
                default:                                // ǂłȂꍇ
                    break;
            }
        }
    }
}
/**************************************************
 * n[hEFA
 * @DMAAADC
 **************************************************/
void Init(void){
    /*** DMA CH0 Setting **/
    DMACONbits.DMAEN = 1;                   // DMA Enable
    DMACONbits.PRSSEL = 0;                  // Fixed Priority
    DMAH = 0x2000;                          // Upper Limit
    DMAL = 0x800;                           // Lower Limit
    DMACH0 = 0;                             // Stop Channel
    DMACH0bits.RELOAD = 1;                  // Reload DMASRC, DMADST, DMACNT
    DMACH0bits.TRMODE = 1;                  // Repeat Oneshot    
    DMACH0bits.SAMODE = 0;                  // Source Addrs No Increment
    DMACH0bits.DAMODE = 1;                  // Dist Addrs Increment
    DMACH0bits.SIZE = 0;                    // Word Mode(16bit)
    DMASRC0 = (unsigned int)&ADRES0;        // From ADC Buf0 select
    DMADST0 = (unsigned int)&Buffer[0];     // To Buffer select
    DMACNT0 = Max_Size;                     // DMA Counter
    DMAINT0 = 0;                            // All Clear
    DMAINT0bits.CHSEL = 0x2F;               // Select Pipeline ADC
    DMACH0bits.CHEN = 1;                    // Channel Enable
    IFS0bits.DMA0IF = 0;                    // Flag Reset
    /** ADCpdobt@L **/
    BUFCON1bits.BUFREF = 3;                 // 3.072V
    BUFCON1bits.BUFEN = 1;                  // Enable    
    /*** ADC Setting ***/
    ADCON1 = 0;                             // All Clear
    ADCON2 = 0;
    ADCON3 = 0;
    ADCON1bits.FORM = 0;                    // unsigned Integer
    ADCON1bits.PWRLVL = 1;                  // Full Power
    ADCON2bits.ADPWR = 3;                   // Always powered
    ADCON2bits.PVCFG = 2;                   // Vref+=BGBUF1
    ADCON2bits.NVCFG = 0;                   // Vref-=VSS
    ADCON2bits.BUFORG = 1;                  // Use Indexed Buffer
    ADCON2bits.BUFINT = 0;                  // No buffer Interrupt
    ADCON3bits.ADRC = 0;                    // Select Fsys = 16MHz
    ADCON3bits.ADCS = 1;                    // Tad = 2Tsys = 125nsec(8MHz)
    /** Sample List #0 setting**/
    ADL0CONH = 0;
    ADL0CONHbits.ASEN = 0;                  // disable auto-scan
    ADL0CONHbits.SLINT = 1;                 // Interrupt after every convert
    ADL0CONHbits.SAMC = 0;                  // aquisition time = 0.5Tad
    ADL0CONHbits.WM = 0;                    // all write
    ADL0CONL = 0;
    ADL0CONLbits.SLSIZE = 0;                // 1 channel in the List
    ADL0CONLbits.SLTSRC = 5;                // Timer2 Trigger
    ADL0CONLbits.SLEN = 1;                  // Enable Trigger
    ADL0PTR = 0;                            // Start from first
    /** Select Channel **/
    ADTBL0bits.ADCH = 18;                    // AN18-REF-
    /** Execute Calibration ADC **/
    ADCON1bits.ADON = 1;                    // ADC Enable
    while(ADSTATHbits.ADREADY == 0);
    ADCON1bits.ADCAL = 1;                   // Calibration Start
    while(ADSTATHbits.ADREADY == 0);
    ADL0CONLbits.SAMP = 1;                  // Start Sample
    ADL0CONLbits.SAMP = 0;                  // Start Conversion    
}
/***************************************************
* ؂ւ@^C}2̎ύX
*  PR2 62.5nsecPʂŐݒ Min 250nsec(4MHz)
***************************************************/
void Hsync(unsigned char num){
    switch(num){
        case '0':                       // 0.025usec  5usec/div
        case '1':                       // 0.05usec  10usec/div
        case '2':                       // 0.25usec  50us/div
            ADCON3bits.ADCS = 1;        // Tad = 2Tsys = 125nsec(8MHz)
            ADL0CONHbits.SAMC = 0;      // aquisition time = 0.5Tad
            PR2 = 3;                    // 16MHz/4=0.25usec  25usec
            break;
        case '3':
            ADCON3bits.ADCS = 2;        // Tad = 4Tsys = 250nsec(4MHz)
            ADL0CONHbits.SAMC = 1;      // aquisition time = Tad
            PR2 = 7;                    // 0.5usec  100us/div
            break;
        case '4':
            ADCON3bits.ADCS = 4;        // Tad = 8Tsys = 500nsec(2MHz)
            ADL0CONHbits.SAMC = 2;      // aquisition time = 2Tad
            PR2 = 79;                   // 5usec  1msec/div
            break;
        case '5':
            ADCON3bits.ADCS = 4;        // Tad = 8Tsys = 500nsec(2MHz)
            ADL0CONHbits.SAMC = 4;      // aquisition time = 5Tad
            PR2 = 159;                  // 10usec  2msec/div
            break;
        case '6':
            ADCON3bits.ADCS = 4;        // Tad = 8Tsys = 500nsec(2MHz)
            ADL0CONHbits.SAMC = 7;      // aquisition time = 8Tad
            PR2 = 799;                  // 50usec  10msec/div
            break;
        default:                        // ǂłȂꍇύXȂ
            break;
    }
}
/************************************************
*  UARTM荞ݏ֐
 *  SThcmmrE     (8oCgM)
 *   h:I@@cF`lI
 * @mmFgKxl@rF艺
************************************************/
void __attribute__((interrupt, no_auto_psv))  _U1RXInterrupt(void){
    char  data;

    /* MG[`FbN */
    IFS0bits.U1RXIF = 0;                    // 荞݃tONA
    if(U1STAbits.OERR || U1STAbits.FERR) {
        data = U1RXREG;;
        U1STA &= 0xFFF0;                    // G[tONA
        U1MODE = 0;                         // UART1~
        U1MODE = 0x8808;                    // UART1L
        U1STA =  0x0400;                    // TX Enable       
        Index = 0;
    }
    else {                                  // M̏ꍇ
        if(Index < 16){                     // 16oCgȉ̏ꍇ
            data = U1RXREG;                 // f[^o
            RcvBuf[Index++] = data;         // obt@i[ 
            if(data == 'E'){                // I
                RcvBuf[Index] = 0;          // I}[NZbg
                Flag = 1;                   // MtOI
                Index = 0;                  // |C^Zbg
            }
        }
        else                                // obt@I[o[̏ꍇ
            data = U1RXREG;                 // ǂݔ΂Ė
    }
}
 /********************************
 * UART MsTu֐
 ********************************/
void Send(unsigned char Data){
    while(!U1STAbits.TRMT);              // MfB[҂
    U1TXREG = Data;                      // Ms
}
/*******************************************
 * f[^񑗐M֐@2000Tv
 *******************************************/
void SendData(unsigned int * buf)
{
    int i;
   
    for(i=0; i< 2000; i++){                 // 4KoCgꊇM
        Send((unsigned char)((*buf%128)+0x80));   // ʃoCgM
        Send((unsigned char)((*buf/128)+0x80));   // ʃoCgM
        buf++;
    }
}
/***********************************************
* ^C}4ɂ1msecPʂ̒x֐ Tcy=16MHz
***********************************************/
void Delayms( unsigned int t){
    IFS1bits.T4IF = 0;                  // 荞݃tONA
    PR4 = 2000;                         // 1msecݒ
    T4CON = 0x8010;                     // ^C}4X^[g@vXP[ 1/8
    while (t--) {                       // JԂ
        while (!IFS1bits.T4IF);         // 1msec҂
        IFS1bits.T4IF = 0;              // 荞݃tONA
    }
}


